<?php

/**
 * Catlair PHP
 * Пользовательские публичные функции
 *
 * still@itserv.ru
 */



/*
 * Пользовательское создание новго дескрипта из формы
 */
function DescriptCreatePublic($AParams, $AResult)
{
    clBeg('');
    $Result = rcUnknown;

    // Получение параметров
    global $clSession;
    $IDLang = clGetLang(clGetIncome('IDLang', $AParams, null));
    $Site = clGetIncome('IDSite', $AParams,  $clSession->GetSite());
    $IDParent = clGetIncome('IDParent', $AParams, '');
    $IDBind = clGetIncome('IDBind', $AParams, BIND_DEFAULT);
    $IDType = clGetIncome('IDType', $AParams, TYPE_DEFAULT);
    $ID = clGetIncome('ID', $AParams, '');
    $Caption = clGetIncome('Caption', $AParams, '');
    $Content = clGetIncome('Content', $AParams, '');
    $Tag = StringToTag(clGetIncome('Tag', $AParams, ''));

    if ($IDType==null || $IDType=='') $Result = 'DescriptTypeUnknown';
    else
    {
        $d = new TDescript('');
        $Result = $d->Create($ID, $IDType, $Site);
        if ($Result==rcOk)
        {
            // Запись параметров дескрипта
            $d->SetLang($IDLang, 'Caption', $Caption);
            $d->Set('Tag', $Tag);

            // Закидываем в дескрипт весь пост
            $d->ArrayStore('Post', $_POST);

            // Закидываем в дескрипт весь сервер
            $d->ArrayStore('Server', $_SERVER);

            // Установка связей для родителя
            $Parent=new TDescript();
            $Result = $Parent->Read($IDParent, $Site);
            if ($Result == rcOk)
            {
                $Result = $d->BindBegin($Parent);
                $Result = $d->Bind($Parent, $IDBind, false);
                $Result = $d->Bind($Parent, BIND_RIGHT, false);
                $Result = $d->BindEnd($Parent);
            }
            unset($Parent);

            if ($Result == rcOk)
            {
                $Result = $d->Flush();
                if ($Result == rcOk)
                {
                    $AResult->Set('ID', $d->ID);
                    $AResult->Set('IDParent', $IDParent);
                    if ($Content!='') $d->ContentWrite($IDLang, $Content);
                }
            }
        }
        unset($d);
    }
    $AResult->SetCode($Result);
    clEnd($Result);
    return true;
}
